/*
 * AtomFragmentsMap.hpp
 *
 *  Created on: Mar 7, 2016
 *      Author: heber
 */


#ifndef ATOMFRAGMENTSMAP_HPP_
#define ATOMFRAGMENTSMAP_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <list>
#include <map>

class atom;
class KeySet;
class Graph;

/** This class creates in instantiation a map connecting each atom with
 * the (known) fragments it takes part in.
 *
 */
class AtomFragmentsMap
{
public:
  AtomFragmentsMap(
      const Graph &_graph,
      size_t _MaxOrder);

  typedef std::list<const KeySet *> keysets_t;
  //!> typedef for the internal map
  typedef std::map<const atom *, keysets_t> AtomFragmentsMap_t;

  const AtomFragmentsMap_t& getMap() const
  { return atommap; }

private:
  //!> internal map filled on instantiation
  AtomFragmentsMap_t atommap;
};


#endif /* ATOMFRAGMENTSMAP_HPP_ */
